Packager: Igor Vlasenko <viy@altlinux.ru>
BuildRequires: /proc
BuildRequires: jpackage-compat
# Copyright (c) 2000-2008, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_with bootstrap

%define _with_repolib 1

# If you want repolib package to be built,
# issue the following: 'rpmbuild --with repolib'
%define with_repolib %{?_with_repolib:1}%{!?_with_repolib:0}
%define without_repolib %{!?_with_repolib:1}%{?_with_repolib:0}

%define reltag SP8
%define repodir %{_javadir}/repository.jboss.com/jboss/remoting/%{version}.%{reltag}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

# FIXME
%define _without_tests 1

# If you don't want to run the unit tests
# give rpmbuild option '--without tests'

%define with_tests %{!?_without_tests:1}%{?_without_tests:0}
%define without_tests %{?_without_tests:1}%{!?_without_tests:0}


Name:           jboss-remoting
Version:        2.2.2
Release:        alt1_3.SP8.1jpp5
Epoch:          0
License:        LGPLv2+
Group:          Development/Java
Summary:        JBoss Remoting
URL:            http://labs.jboss.com/portal/index.html?ctrl:id=page.default.info&project=jbossremoting
# svn export http://anonsvn.jboss.org/repos/jbossremoting/remoting2/tags/2.2.2-SP8/ JBossRemoting
# tar czf jboss-remoting-2.2.2.SP8-src.tar.gz JBossRemoting
Source0:        jboss-remoting-2.2.2.SP8-src.tar.gz
Source1:	jboss-remoting-component-info.xml
# FIXME We need to update this patch to force IPv4 to be used on Linux
Patch0:         jboss-remoting-1.4.3-build_xml.patch
BuildArch:      noarch
BuildRequires: jpackage-utils >= 0:1.6
BuildRequires: ant >= 0:1.6
BuildRequires: junit
BuildRequires: jboss-jrunit
BuildRequires: xmlgraphics-batik
BuildRequires: xmlgraphics-fop
BuildRequires: saxon
BuildRequires: concurrent
BuildRequires: dom4j
BuildRequires: jakarta-commons-httpclient
BuildRequires: jakarta-commons-logging
BuildRequires: log4j
BuildRequires: tomcat5-server-lib >= 0:5.5.16-3jpp
BuildRequires: tomcat5-servlet-2.4-api
BuildRequires: jboss-common
%if %with bootstrap
BuildRequires: jboss4-jmx
BuildRequires: jboss4-naming
%else
BuildRequires: jbossas
%endif
BuildRequires: jboss-serialization
BuildRequires: jgroups >= 0:2.2.9.2
BuildRequires: jcommon
BuildRequires: jfreechart
BuildRequires: spring
BuildRequires: aopalliance
BuildRequires: hessian
BuildRequires: gnu-trove
BuildRequires: zip
Requires: jpackage-utils >= 0:1.6
Requires: concurrent
Requires: dom4j
Requires: jakarta-commons-httpclient
Requires: jakarta-commons-logging
Requires: log4j
# EAP only - JBoss Remoting will be deployed on a server that will have
# all the necessary bits
#Requires:       tomcat5-server-lib >= 0:5.5.17
Requires: tomcat5-servlet-2.4-api
Requires: jboss-common
Requires: jboss-serialization
Requires: jgroups >= 0:2.2.9.2
Requires: jcommon
Requires: jfreechart
%if %with bootstrap
Requires: jboss4-jmx
Requires: jboss4-naming
%else
Requires: jbossas
%endif

%description
The purpose of JBoss Remoting is to provide a single API for most 
network based invocations and related service that uses pluggable 
transports and data marshallers. The JBoss Remoting API provides 
the ability for making synchronous and asynchronous remote calls, 
push and pull callbacks, and automatic discovery of remoting servers. 
The intention is to allow for the addition of different transports 
to fit different needs, yet still maintain the same API for making 
the remote invocations and only requiring configuration changes, 
not code changes, to fit these different needs.

%if %{with_repolib}
%package repolib
Summary:	 Artifacts to be uploaded to a repository library
Group:	         Development/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio
%endif

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation
BuildArch: noarch

%description javadoc
%{summary}.

%package manual
Summary:        Documents for %{name}
Group:          Development/Documentation
BuildArch: noarch

%description manual
%{summary}.

%package demo
Summary:        Usage examples for %{name}
Group:          Development/Documentation

%description demo
%{summary}.

%prep
%setup -q -n JBossRemoting
chmod -R go=u-w *
find . -name "*.jar" | xargs rm

# FIXME
#%%patch0 -b .sav

# Work with recent versions of fop
%{__perl} -pi -e 's/org\.apache\.fop\.apps\.Fop/org.apache.fop.cli.Main/g' docs/Multiplex/build.xml docs/guide/support/support.xml

%build
#docs/guide/support/support/lib/avalon-framework-cvs-20020806.jar.no
#docs/guide/support/support/lib/batik.jar.no
#docs/guide/support/support/lib/fop.jar.no
#docs/guide/support/support/lib/jai_codec.jar.no
#docs/guide/support/support/lib/jai_core.jar.no
#docs/guide/support/support/lib/rowan-0.1.jar.no
#docs/guide/support/support/lib/saxon-dbxsl-extensions.jar.no
#docs/guide/support/support/lib/saxon.jar.no
pushd docs/guide/support/support/lib
build-jar-repository -s -p . \
excalibur/avalon-framework-api \
xmlgraphics-batik \
xmlgraphics-fop \
saxon
popd
#lib/apache-commons/lib/commons-httpclient.jar.no
#lib/apache-commons/lib/commons-logging-api.jar.no
pushd lib/apache-commons/lib
ln -sf $(build-classpath commons-httpclient) .
ln -sf $(build-classpath commons-logging-api) .
popd
#lib/apache-log4j/lib/log4j.jar.no
pushd lib/apache-log4j/lib
ln -sf $(build-classpath log4j) .
popd
#lib/apache-tomcat/tomcat-apr.jar.no
#lib/apache-tomcat/tomcat-coyote.jar.no
#lib/apache-tomcat/tomcat-http.jar.no
#lib/apache-tomcat/tomcat-util.jar.no
pushd lib/apache-tomcat
ln -sf $(build-classpath tomcat5/tomcat-apr) .
ln -sf $(build-classpath tomcat5/tomcat-coyote) .
ln -sf $(build-classpath tomcat5/tomcat-http) .
ln -sf $(build-classpath tomcat5/tomcat-util) .
popd
#lib/dom4j/lib/dom4j.jar.no
pushd lib/dom4j/lib
ln -sf $(build-classpath dom4j) .
popd
#lib/jboss/jboss-common.jar.no
#lib/jboss/jboss-jmx.jar.no
#lib/jboss/jboss-serialization.jar.no
#lib/jboss/jnpserver.jar.no
#lib/jboss/jrunit.jar.no
pushd lib/jboss
ln -sf $(build-classpath jboss-common/jboss-common) .
%if %with bootstrap
ln -sf $(build-classpath jboss4/jnpserver.jar) .
ln -sf $(build-classpath jboss4/jboss-jmx.jar) .
%else
ln -sf $(build-classpath jbossas/jboss-jmx) .
ln -sf $(build-classpath jbossas/jnpserver) .
%endif
ln -sf $(build-classpath jboss-jrunit) .
ln -sf $(build-classpath jboss-serialization) .
popd
#lib/jgroups/lib/jgroups.jar.no
pushd lib/jgroups/lib
ln -sf $(build-classpath jgroups) .
popd
#lib/jrunit-libs/lib/jcommon-1.0.0-rc1.jar.no
#lib/jrunit-libs/lib/jfreechart-1.0.0-rc1.jar.no
pushd lib/jrunit-libs/lib
ln -sf $(build-classpath jcommon) .
ln -sf $(build-classpath jfreechart) .
popd
#lib/junit/lib/junit.jar.no
pushd lib/junit/lib
ln -sf $(build-classpath junit) .
popd
#lib/oswego-concurrent/lib/concurrent.jar.no
pushd lib/oswego-concurrent/lib
ln -sf $(build-classpath concurrent) .
popd
#lib/spring/aopalliance/aopalliance.jar.no
pushd lib/spring/aopalliance
ln -sf $(build-classpath aopalliance) .
popd
#lib/spring/spring*.jar.no
pushd lib/spring
build-jar-repository . spring
popd
#lib/spring/caucho/hessian-2.1.12.jar.no
pushd lib/spring/caucho
ln -sf $(build-classpath hessian) .
popd
#lib/sun-servlet/lib/servlet-api.jar.no
pushd lib/sun-servlet/lib
ln -sf $(build-classpath servletapi5) servlet-api.jar
popd
#lib/trove/lib/trove.jar.no
pushd lib/trove/lib
ln -sf $(build-classpath gnu-trove) trove.jar
popd

%if %{with_tests}
export ANT_OPTS="-Djava.net.preferIPv4Stack=true"
ant -Dant.build.javac.source=1.4 -Dant.build.javac.target=1.4 -Dcompile.source="1.4" -Dcompile.target="1.4" jars javadoc tests
%else
ant -Dant.build.javac.source=1.4 -Dant.build.javac.target=1.4 -Dcompile.source="1.4" -Dcompile.target="1.4" jars javadoc
%endif

ant -Dant.build.javac.source=1.4 -Dant.build.javac.target=1.4 -Dcompile.source="1.4" -Dcompile.target="1.4" dist.only

%install

# jar
install -d -m 0755 $RPM_BUILD_ROOT%{_javadir}
install -p -m 0644 output/lib/jboss-remoting.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

# etc
install -d -m 0755 $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}
cp -pr output/etc   $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}
rm -fr $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/etc/lib
cp -pr output/lib/servlet-invoker.war   $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr output/doc/api/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
%{__ln_s} %{name}-%{version} %{buildroot}%{_javadocdir}/%{name}

# manual
mkdir -p $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
mkdir -p $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}/guide
mkdir -p $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}/multiplex
cp -a docs/*.pdf docs/*.sxd docs/*.txt $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}/
cp -a docs/guide/build/en/html $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}/guide/
cp -a docs/Multiplex/build/en/html $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}/multiplex/

%if %{with_repolib}
	install -d -m 755 $RPM_BUILD_ROOT%{repodir}
	install -d -m 755 $RPM_BUILD_ROOT%{repodirlib}
	install -p -m 0644 %{SOURCE1} $RPM_BUILD_ROOT%{repodir}/component-info.xml
        sed -i 's/@VERSION@/%{version}.%{reltag}-brew/g' $RPM_BUILD_ROOT%{repodir}/component-info.xml
        tag=`echo %{name}-%{version}-%{release} | sed 's|\.|_|g'`
        sed -i "s/@TAG@/$tag/g" $RPM_BUILD_ROOT%{repodir}/component-info.xml
	install -d -m 755 $RPM_BUILD_ROOT%{repodirsrc}
	install -p -m 0644 %{SOURCE0} $RPM_BUILD_ROOT%{repodirsrc}
	cp -p $RPM_BUILD_ROOT%{_javadir}/jboss-remoting.jar $RPM_BUILD_ROOT%{repodirlib}
        # Add the source again for some eclipse jboss project use
        tar xzf %{SOURCE0}
        pushd JBossRemoting/src/main
        %{jar} cf $RPM_BUILD_ROOT%{repodirlib}/jboss-remoting-src.jar org
        popd
        rm -r JBossRemoting
%endif

%files
%{_javadir}/*.jar
%{_datadir}/%{name}-%{version}/etc
%{_datadir}/%{name}-%{version}/servlet-invoker.war

%files javadoc
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%files manual
%doc %{_docdir}/%{name}-%{version}

%if %{with_repolib}
%files repolib
%{repodir}
%endif

%changelog
* Sat Mar 06 2010 Igor Vlasenko <viy@altlinux.ru> 0:2.2.2-alt1_3.SP8.1jpp5
- new version

* Fri Mar 05 2010 Igor Vlasenko <viy@altlinux.ru> 0:2.2.2-alt0.1jpp
- bootstrap for jbossas

